#ifndef BLUECORE_TEXTURE_IMAGE_H
#define BLUECORE_TEXTURE_IMAGE_H

#include "TextureManager.h"
#include "RenderDevice.h"

namespace BlueCore
{
	class TextureImage : public Referenced
	{
		ref_ptr<Texture> _Texture;
		ref_ptr<RenderDevice> _Device;
		float _Vertices[3 * 4];
		float _TexCoords[2 * 4];
		unsigned int _Width, _Height;

	public:
	  TextureImage (RenderDevice* device, Texture *texture, float ax, float ay, float bx, float by );
		~TextureImage();
		void draw (float x, float y, int halign = 0, int valign = 0, float r = 0.0 );
		unsigned int getWidth();
		unsigned int getHeight();
	};
}

#endif /*IMAGE_H_*/
